#+ELEVENTY_COLLECTIONS: _posts
#+ELEVENTY_BASE_DIR: ~/proj/static-blog/
#+ELEVENTY_BASE_URL: https://sachachua.com


* My Evil Plan for Yay Emacs!  :YayEmacs:emacs:planning:
:PROPERTIES:
:EXPORT_DATE: 2024-01-23T07:43:47-0500
:EXPORT_ELEVENTY_PERMALINK: /blog/2024/01/my-evil-plan-for-yay-emacs/
:EXPORT_ELEVENTY_FILE_NAME: blog/2024/01/my-evil-plan-for-yay-emacs/
:ARCHIVE_TIME: 2024-01-25 Thu 08:32
:ARCHIVE_FILE: ~/sync/orgzly/posts.org
:ARCHIVE_CATEGORY: posts
:END:

Here's a clip from my [[https://www.youtube.com/watch?v=Pc2kpqgg8pU][2024-01-21 Yay Emacs livestream]] about my goals for Yay Emacs and the built-in payoffs that I think will help me keep doing it.

#+begin_audio-post
#+begin_sticky-base
#+begin_sticky-at-top
#+begin_center
[[audio:/home/sacha/proj/2024-yay-emacs/2024-01-21/2024-01-21-evil-plans-for-yay-emacs.opus?captions=/home/sacha/proj/2024-yay-emacs/2024-01-21/2024-01-21-evil-plans-for-yay-emacs.vtt&id=evil-plans-audio]]
#+end_center
#+end_sticky-at-top

[[my-include:~/proj/2024-yay-emacs/2024-01-21/2024-01-split-times.svg?wrap=export html]]
#+begin_src emacs-lisp :exports results :eval never-export
(mapconcat
 (lambda (o)
	 (format "- @@html:<span class=\"audio-time\" data-start=\"%.3f\" data-stop=\"%.3f\">%s</span>@@: *%s*:\n  %s\n\n"
					 (/ (plist-get o :start-ms) 1000.0)
					 (/ (plist-get o :stop-ms) 1000.0)
					 (substring (my-msecs-to-timestamp (plist-get o :start-ms)) 3)
					 (plist-get o :comment)
					 (string-trim (replace-regexp-in-string
												 "[ \n]+" " "
												 (subed-subtitle-list-text (plist-get o :subtitles)))
					 )))
 (my-subed-group-sections
	(subed-parse-file "/home/sacha/proj/2024-yay-emacs/2024-01-21/2024-01-21-evil-plans-for-yay-emacs.vtt")))
#+end_src

#+RESULTS:
:results:
- @@html:<span class="audio-time" data-start="0.000" data-stop="19.560">00:00.000</span>@@: *Getting more ideas into blog posts and workflow demos*:
  Now, also, I have an evil plan. My evil plan is that this is a good way for me to get ideas and convert them into blog posts and code and then do the workflow demos, because it's sometimes really difficult to see how to use something from just the code.

- @@html:<span class="audio-time" data-start="20.340" data-stop="24.180">00:20.340</span>@@: *I have fun tickling my brain*:
  This process is fun. Tweaking Emacs is fun for me.

- @@html:<span class="audio-time" data-start="24.840" data-stop="34.220">00:24.840</span>@@: *I learn from other people's comments, questions*:
  Also, if I do this out loud, other people can help out with questions and comments, like the way that you're all doing now, which is great. Fantastic.

- @@html:<span class="audio-time" data-start="35.200" data-stop="56.060">00:35.200</span>@@: *Other people pick up ideas*:
  Of course, those are all very selfish reasons. So I'm hoping other people are getting something out of this too. (Hello, 19 people who are watching, and also for some reason, the hundreds of people who check these videos out afterwards. Great, fantastic.) I'm hoping you pick up some ideas from the crazy things that we like to play with in terms of Emacs.

- @@html:<span class="audio-time" data-start="57.440" data-stop="90.920">00:57.440</span>@@: *We bounce ideas around and make lots of progress*:
  My medium-term plan there is then to start seeing how those ideas get transformed when they get bounced off other people and other people bounce ideas back. Because that's one of the fun things about Emacs, right? Everything is so personalizable that seeing how one workflow idea gets transformed into somebody else's life, you learn something from that process. I'm really looking forward to how bouncing ideas around will work here.

- @@html:<span class="audio-time" data-start="92.200" data-stop="104.800">01:32.200</span>@@: *More people share more*:
  Especially if we can find little things that make doing things more fun or they make it take less effort--then maybe more people will share more things, and then I get to learn from that also,

- @@html:<span class="audio-time" data-start="106.940" data-stop="130.680">01:46.940</span>@@: *Building up an archive*:
  which is fantastic because long term, this can help build up an archive. Then people can go into that archive and find things without necessarily waiting for me. I don't become the bottleneck. People can just go in there and find... "Oh, you remember that time that I saw this interesting idea about SVG highlighting or whatever." You can just go in there and try to find more information.

- @@html:<span class="audio-time" data-start="131.640" data-stop="161.580">02:11.640</span>@@: *More people join and thrive in the Emacs community*:
  So that's great. Then ideally, as people find the things that resonate with them, the cool demos that say this text editor can be extended to do audio editing and animation and all that crazy stuff, then more people will come and join and share what they're learning, and then move on to building stuff maybe for themselves and for other people, and then it'll be even more amazing.

- @@html:<span class="audio-time" data-start="162.780" data-stop="319.866">02:42.780</span>@@: *I could be a voice in people's heads*:
  And lastly, this is kind of odd, but having listened in the background to so many of the kiddo's current viewing habits, her favorite YouTube channels like J Perm or Cubehead or Tingman for Rubik's cube videos or Eyecraftmc for Minecraft, I'm beginning to appreciate kind of the value of having these mental models of other people in your head. I can imagine how they talk and all that stuff. I am looking forward to watching more Emacs videos, which I haven't done in a while because usually for Emacs News, I'm just skimming through the transcripts super quickly on account of (A), lots of videos and (B), not much time. So this idea of getting other people's voices into your head, or possibly becoming a voice in somebody's head, I think there might be something interesting there. Of course, the buzz these days is, "oh no, AI voice cloning, this is a safety issue and all of that stuff." But I think there are positive uses for this as well, in the sense that... As qzump says, you know, they are like, "I have no Emacs friends and you're speaking to my soul." A lot of us are doing this in isolation. We don't normally meet other people. So the more voices we can have in our heads of actual people who enjoy doing these things, the less weird we feel. Or actually, more like... the more weird we feel, but in a good way, like there's a tribe, right? If sharing more ideas in a multimedia sort of way, like with either audio narration with images or this webcam thing that we're trying (my goodness, I have to actually dress up) helps people build these mental models in their head... Hey, one of the nice things about this webcam thing is I can make hand gestures. Cool, cool. Might be interesting. If, while you're hacking on Emacs, you can imagine me cheering you on and saying, "That's fantastic. Have you thought about writing a blog post about that so that we get that into Planet Emacs Life and, and then into Emacs News? Please share what you're learning." It'll be great. So, yeah, maybe that's a thing. So that's my evil plan for Yay Emacs.

:end:

#+end_sticky-base
#+begin_export html
<style>
 .sticky-at-top { position: sticky; top: 0 }
 .audio audio { width: 100%; }
 .audio { background: white; border: 1px solid gray; padding-top: 5px; padding-left: 5px; padding-right: 5px }
 .audio.js .audio-note { cursor: pointer }
 .audio.js .audio-note:hover { fill: #f6f396 !important; background-color: #f6f396 }
 svg .highlight { fill: #f6f396 !important }
 @media only screen and (min-width: 1080px) {
    /* break out */
    .audio-post svg { float: right }
 }
</style>
<script>
 (function(elem) {
	 let audio = elem.querySelector('audio');
       elem.querySelector('.audio').classList.add('js');
	 elem.querySelectorAll('.audio-time').forEach((audioTime) => {
		 // Turn them into buttons
		 audioTime.setAttribute('role', 'button');
		 audioTime.addEventListener('click', function(event) {
		 audio.currentTime = event.target.getAttribute('data-start');
		 });
	 });
       audio.textTracks[0].addEventListener('cuechange', function() {
         elem.querySelectorAll('.audio-time').forEach((audioTime) => {
          if ((parseFloat(audioTime.getAttribute('data-start')) <= audio.currentTime) &&
              (parseFloat(audioTime.getAttribute('data-stop')) > audio.currentTime)) {
				 audioTime.classList.add('highlight');
			 } else {
				 audioTime.classList.remove('highlight');
			 }
		 });
	 });
 })(document.currentScript.closest('.audio-post'));
</script>
#+end_export
#+end_audio-post
** COMMENT Prepare the image

#+begin_src emacs-lisp :eval no :results file
(my-sketch-convert-pdf-and-break-up-paths
 "~/proj/2024-yay-emacs/2024-01-21/2024-01.pdf"
 :color-scheme 'blue
 :selector (lambda (o) (string-match "#c" (or (dom-attr o 'style) ""))))
#+end_src

#+RESULTS:
:results:
[[file:/home/sacha/proj/2024-yay-emacs/2024-01-21/2024-01-split.svg]]
:end:


#+RESULTS:
:results:
nil
:end:

#+begin_src emacs-lisp :eval no
(my-svg-identify-paths
 "~/proj/2024-yay-emacs/2024-01-21/2024-01-split.svg"
 (lambda (o) (string-match "#b3" (or (dom-attr o 'style) ""))))
#+end_src

#+RESULTS:
:results:
nil
:end:

Now I want to get the IDs.

#+begin_src emacs-lisp :results table
(let ((dom (xml-parse-file "~/proj/2024-yay-emacs/2024-01-21/2024-01-split.svg")))
	(seq-keep (lambda (p) (when (string-match "h-" (dom-attr p 'id))
													(list (dom-attr p 'id))))
						(dom-search dom (lambda (p) (dom-attr p 'id)))))
#+end_src

#+begin_src emacs-lisp
(defun my-sketch-add-times (dom ids-and-times)
	(dolist (p (dom-by-tag dom 'path))
		(when-let ((row (assoc-default (dom-attr p 'id) ids-and-times)))
			(dom-set-attribute p 'class "audio-time")
			(dom-set-attribute p 'data-start
												 (format "%.3f"
																 (/ (compile-media-timestamp-to-msecs (elt row 0))
																		1000.0)))
			(dom-set-attribute p 'data-stop
												 (format "%.3f"
																 (/ (compile-media-timestamp-to-msecs (elt row 1))
																		1000.0)))))
	dom)
#+end_src

#+RESULTS:
:results:
my-sketch-add-times
:end:

#+NAME: ids-and-times
| h-title     | 00:00:00.000 | 00:00:02.140 |
| h-workflow  | 00:00:02.140 | 00:00:19.560 |
| h-tickling  | 00:00:20.340 | 00:00:24.180 |
| h-comments  | 00:00:24.840 | 00:00:34.220 |
| h-ideas     | 00:00:35.200 | 00:00:56.060 |
| h-bounce    | 00:00:57.440 | 00:01:30.920 |
| h-tweaks    | 00:01:32.200 | 00:01:44.800 |
| h-archive   | 00:01:46.940 | 00:02:10.680 |
| h-community | 00:02:11.640 | 00:02:41.580 |
| h-models    | 00:02:42.780 | 00:05:19.866 |


#+begin_src emacs-lisp :results table :var times=ids-and-times
(let ((dom (xml-parse-file "~/proj/2024-yay-emacs/2024-01-21/2024-01-split.svg")))
	(with-temp-file "~/proj/2024-yay-emacs/2024-01-21/2024-01-split-times.svg"
		(svg-print (car
								(my-sketch-add-times dom times)))
		))


#+end_src

#+RESULTS:
:results:
:end:
